/**********************************************************************
** Copyright (C) 2000-2002 Trolltech AS.  All rights reserved.
**
** This file is part of the Qtopia Environment.
**
** This file may be distributed and/or modified under the terms of the
** GNU General Public License version 2 as published by the Free Software
** Foundation and appearing in the file LICENSE.GPL included in the
** packaging of this file.
**
** This file is provided AS IS with NO WARRANTY OF ANY KIND, INCLUDING THE
** WARRANTY OF DESIGN, MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE.
**
** See http://www.trolltech.com/gpl/ for GPL licensing information.
**
** Contact info@trolltech.com if any conditions of this licensing are
** not clear to you.
**
**********************************************************************/
#ifndef BATTERY_H
#define BATTERY_H

#define POWER_STATUS	"Power Status"
#define STD_SETTING     "Setting"
#define SETTING1        "242"
#define SETTING2        "161"
#define SETTING3        "241"
#define	C3000_SETTING1	"02000218"
#define	C3000_SETTING2	"02000214"
#define	C3000_SETTING3	"02000210"
#define BATT_MODE       "Battery mode"
#define USE_AC_ADAPTER	"AC"
#define	USE_BATTERY	"BATT"

#define BATT100	"BATT100"
#define BATT75	"BATT75"
#define BATT50	"BATT50"
#define BATT25	"BATT25"
#define BATT5	"BATT5"

#define MAX_CLOCK_LIST 20

#include <qwidget.h>
#include <qguardedptr.h>
#include <qpopupmenu.h>
#include <qstring.h>
#include <qfile.h>
#include <qpe/qcopenvelope_qws.h>

class BatteryData;
class BatteryStatus;
class QTimer;

struct Clock_list {
  Clock_list(){
    name = "";
    clock = 0x0000;
    vcore = 0x00;
    batt_pc = 0;
    checked = FALSE;
  }
  
  QString	name;
  unsigned int	clock;
  unsigned int  vcore;
  int	batt_pc;
  bool  checked;
};

class BatteryMeter : public QWidget
{
  Q_OBJECT
    public:
  BatteryMeter( QWidget *parent = 0 );
  ~BatteryMeter();
  
  QSize sizeHint() const;
  
protected:
  void timerEvent( QTimerEvent * );
  void paintEvent( QPaintEvent* );
  void showPowerStatus();
  void mousePressEvent( QMouseEvent * );
  void loadConfig();

  void changeClock(int clock, int vcore);

  
protected slots:
  void chargeTimeout();
  void action(int);
  void receiveMessage(const QCString& msg, const QByteArray& data);
 
protected:
  QCopChannel* myChannel;

  QGuardedPtr<BatteryStatus> batteryView;
  BatteryData *ps;
  QSize bvsz;
  QTimer *chargeTimer;
  int percent;
  bool charging;
  bool updateBatteryViewGeometry();
  
  QPopupMenu* menu;
  unsigned int	cpuregister;
  unsigned int  vcoreregister;
  Clock_list	clock_list[MAX_CLOCK_LIST];
  Clock_list	sorted_list[MAX_CLOCK_LIST];
  int item_num;
  bool batt_mode;

  bool isPXA270;
  
  bool SIG_sended;
  
};

#endif
